-- GNU GENERAL PUBLIC LICENSE Version 3
-- Created by Monk3yDev 
-- I will be so happy when this addon become popular.
-- If you want use code from DestroyusPro
-- please let me know about it monk3ydev at gmail dot com 

DestroyusProMain = {}
DestroyusProMain.cif = _DPContainerItemApi()
DestroyusProMain.macroMgr = _DPMacroManager()

DestroyusProMain.buttonNameMilling = "ClickMeForWorkMilling"
DestroyusProMain.buttonNameDisenchanting = "ClickMeForWorkDisenchanting"
DestroyusProMain.buttonNameProspecting = "ClickMeForWorkProspecting"
DestroyusProMain.buttonNameMassMillingLegion = "ClickMeForWorkMassMillingLegion"
DestroyusProMain.buttonNameMassProspectingLegion = "ClickMeForWorkMassProspectingLegion"
DestroyusProMain.buttonNameMassMillingAzeroth = "ClickMeForWorkMassMillingAzeroth"
DestroyusProMain.buttonNameMassProspectingAzeroth = "ClickMeForWorkMassProspectingAzeroth"
DestroyusProMain.isInCombatMode = false
DestroyusProMain.macroMgr:setCombatMode(false)
DestroyusProMain.basicBankSlotNumIndex = 40
DestroyusProMain.reagentBankSlotNumIndex = 87
DestroyusProMain.calibrationStarted = false
DestroyusProMain.calibrationOngoing = false
DestroyusProMain.canLootItemsAfterWork = false
DestroyusProMain.itemFoundAndWorkStarted = false
DestroyusProMain.buttonCanWorkEnable = true
DestroyusProMain.counter = 1
DestroyusProMain.massWorkStarted = false
DestroyusProMain.itemFoundAndMassWorkStarted = false
DestroyusProMain.timerCloseTradeSkill = nil

DestroyusPro = DestroyusProApi()

local frame = CreateFrame("Frame", "DestroyusPro")
frame:RegisterEvent("ADDON_LOADED")

-- Milling --
local ClickMeForWorkMilling = CreateFrame("Button", DestroyusProMain.buttonNameMilling, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMilling:SetAttribute("type", "macro")
ClickMeForWorkMilling:SetAttribute("macrotext", "")
ClickMeForWorkMilling:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMilling:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Disenchant --
local ClickMeForWorkDisenchanting = CreateFrame("Button", DestroyusProMain.buttonNameDisenchanting, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkDisenchanting:SetAttribute("type", "macro")
ClickMeForWorkDisenchanting:SetAttribute("macrotext", "")
ClickMeForWorkDisenchanting:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkDisenchanting:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Prospecting --
local ClickMeForWorkProspecting = CreateFrame("Button", DestroyusProMain.buttonNameProspecting, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkProspecting:SetAttribute("type", "macro")
ClickMeForWorkProspecting:SetAttribute("macrotext", "")
ClickMeForWorkProspecting:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkProspecting:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Mass Milling Legion --
local ClickMeForWorkMassMillingLegion = CreateFrame("Button", DestroyusProMain.buttonNameMassMillingLegion, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMassMillingLegion:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMassMillingLegion:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Mass Prospecting Legion --
local ClickMeForWorkMassProspectingLegion = CreateFrame("Button", DestroyusProMain.buttonNameMassProspectingLegion, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMassProspectingLegion:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMassProspectingLegion:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Mass Milling Battle for Azeroth --
local ClickMeForWorkMassMillingAzeroth = CreateFrame("Button", DestroyusProMain.buttonNameMassMillingAzeroth, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMassMillingAzeroth:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMassMillingAzeroth:RegisterEvent("PLAYER_REGEN_ENABLED")

-- Mass Prospecting Battle for Azeroth --
local ClickMeForWorkMassProspectingAzeroth = CreateFrame("Button", DestroyusProMain.buttonNameMassProspectingAzeroth, UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMassProspectingAzeroth:RegisterEvent("PLAYER_REGEN_DISABLED")
ClickMeForWorkMassProspectingAzeroth:RegisterEvent("PLAYER_REGEN_ENABLED")

local function prettyLoadQuality()
    local msg = "Quality of items:"
    local allDisabled = true
	if _G["DestroyusProItemQualityValue"]["uncommon"] == DestroyusProApi.strToNumQuality["uncommon"] then
	   msg = msg.." *"..DestroyusProApi.numToStrQuality[_G["DestroyusProItemQualityValue"]["uncommon"]]
	   allDisabled = false
	end
	if _G["DestroyusProItemQualityValue"]["rare"] == DestroyusProApi.strToNumQuality["rare"] then
	   msg = msg.." *"..DestroyusProApi.numToStrQuality[_G["DestroyusProItemQualityValue"]["rare"]]
	   allDisabled = false
	end
	if _G["DestroyusProItemQualityValue"]["epic"] == DestroyusProApi.strToNumQuality["epic"] then
	   msg = msg.." *"..DestroyusProApi.numToStrQuality[_G["DestroyusProItemQualityValue"]["epic"]]
	   allDisabled = false
	end
	if allDisabled then
	   msg = msg.." ".."Disabled. Check settings"
	end
	return msg
end

local function prettyLoadMesssage()
	_DPInformationPrint(string.format("Addon successfully loaded. %s", prettyLoadQuality()))
end

local function loadAddonData(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == 'DestroyusPro' then
		if _G["DestroyusProInitDataFirstLoad"] == nil then
			_G["DestroyusProInitDataFirstLoad"] = true
			_G["DestroyusProItemQualityValue"] = DestroyusProApi.strToNumQuality["uncommon"]
			_G["DestroyusProPrintOutState"] = true
		end
		if _G["DestroyusProInitDataLoadDPVersionWithForm0_1_7"] == nil then
		    _G["DestroyusProItemQualityValue"] = {}
			_G["DestroyusProItemQualityValue"]["uncommon"] = DestroyusProApi.strToNumQuality["uncommon"]
			_G["DestroyusProItemQualityValue"]["rare"] = DestroyusProApi.unknowNumber
			_G["DestroyusProItemQualityValue"]["epic"] = DestroyusProApi.unknowNumber
			_G["DestroyusProInitDataLoadDPVersionWithForm0_1_7"] = true
		end
		if _G["DestroyusProSpellsID"] == nil then
			_G["DestroyusProSpellsID"] = {}
			_G["DestroyusProSpellsID"]["MillLegion"] = {}
			_G["DestroyusProSpellsID"]["MillAzeroth"] = {}
			_G["DestroyusProSpellsID"]["ProspectingLegion"] = {}
			_G["DestroyusProSpellsID"]["ProspectingAzeroth"] = {}
		else
			DestroyusPro.ts.spellsMassMillLegion = _G["DestroyusProSpellsID"]["MillLegion"]
			DestroyusPro.ts.spellsMassMillAzeroth = _G["DestroyusProSpellsID"]["MillAzeroth"]
			DestroyusPro.ts.spellsMassProspectigLegion = _G["DestroyusProSpellsID"]["ProspectingLegion"]
			DestroyusPro.ts.spellsMassProspectingAzeroth = _G["DestroyusProSpellsID"]["ProspectingAzeroth"]
		end
		prettyLoadMesssage()
	end
end

local function combatMode(self, event, arg1)
	if event == "PLAYER_REGEN_DISABLED" then
		DestroyusProMain.isInCombatMode = true
		DestroyusProMain.macroMgr:setCombatMode(true)
		return nil
	end
	if event == "PLAYER_REGEN_ENABLED" then
		DestroyusProMain.isInCombatMode = false
		DestroyusProMain.macroMgr:setCombatMode(false)
		return nil
	end
end

local function preClickMacroButton(self, event)
	if DestroyusProMain.isInCombatMode == false and DestroyusProMain.buttonCanWorkEnable == true then
	    DestroyusProMain.canLootItemsAfterWork = false
        DestroyusProMain.itemFoundAndWorkStarted = false
		local result = DestroyusProMain.findItemToWork(_DPSpellApi.spellDisenchant)
		self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(_DPSpellApi.spellDisenchant, result)) -- Disenchant
		DestroyusProMain.printResults(_DPSpellApi.spellDisenchant, result)
	end
end

local function preClickMacroButtonMilling(self, event)
	if DestroyusProMain.isInCombatMode == false and DestroyusProMain.buttonCanWorkEnable == true then
	    DestroyusProMain.canLootItemsAfterWork = false
        DestroyusProMain.itemFoundAndWorkStarted = false
		local result = DestroyusProMain.findItemToWork(_DPSpellApi.spellMilling)
		self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(_DPSpellApi.spellMilling , result)) -- Milling
		DestroyusProMain.printResults(_DPSpellApi.spellMilling , result)
	end
end

local function preClickMacroButtonProspecting(self, event)
	if DestroyusProMain.isInCombatMode == false and DestroyusProMain.buttonCanWorkEnable == true then
	    DestroyusProMain.canLootItemsAfterWork = false
        DestroyusProMain.itemFoundAndWorkStarted = false
		local result = DestroyusProMain.findItemToWork(_DPSpellApi.spellProspecting)
    	self:SetAttribute("macrotext", DestroyusProMain.createMacroUsage(_DPSpellApi.spellProspecting, result)) -- Prospecting
		DestroyusProMain.printResults(_DPSpellApi.spellProspecting, result)
	end
end

local function preClickMacroButtonMassMillingLegion(self, event)
	if DestroyusProMain.isInCombatMode == false then
		DestroyusProMain.createMassWork(DestroyusPro.ts.spellsMassMillLegion, _DPProfessionApi.skilInscription, _DPSpellApi.spellMilling)
	end
end

local function preClickMacroButtonMassProspectingLegion(self, event)
	if DestroyusProMain.isInCombatMode == false then
		DestroyusProMain.createMassWork(DestroyusPro.ts.spellsMassProspectingLegion, _DPProfessionApi.skillJewelcrafting, _DPSpellApi.spellProspecting)
	end
end

local function preClickMacroButtonMassMillingAzeroth(self, event)
	if DestroyusProMain.isInCombatMode == false then
		DestroyusProMain.createMassWork(DestroyusPro.ts.spellsMassMillAzeroth, _DPProfessionApi.skilInscription, _DPSpellApi.spellMilling)
	end
end

local function preClickMacroButtonMassProspectingAzeroth(self, event)
	if DestroyusProMain.isInCombatMode == false then
		DestroyusProMain.createMassWork(DestroyusPro.ts.spellsMassProspectingAzeroth, _DPProfessionApi.skillJewelcrafting, _DPSpellApi.spellProspecting)
	end
end

local function postClickMacroButton(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonMilling(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonProspecting(self, event)
	if DestroyusProMain.isInCombatMode == false then
		self:SetAttribute("macrotext", "")
	end
end

local function postClickMacroButtonMassMillingLegion(self, event)
	if DestroyusProMain.isInCombatMode == false then
	end
end

local function postClickMacroButtonMassProspectingLegion(self, event)
	if DestroyusProMain.isInCombatMode == false then
	end
end

local function postClickMacroButtonMassMillingAzeroth(self, event)
	if DestroyusProMain.isInCombatMode == false then
	end
end

local function postClickMacroButtonMassProspectingAzeroth(self, event)
	if DestroyusProMain.isInCombatMode == false then
	end
end

frame:SetScript("OnEvent", loadAddonData)
-- Set protection to do not create macro in combat
ClickMeForWorkDisenchanting:SetScript("OnEvent", combatMode)
ClickMeForWorkMilling:SetScript("OnEvent", combatMode)
ClickMeForWorkProspecting:SetScript("OnEvent", combatMode)
ClickMeForWorkMassMillingLegion:SetScript("OnEvent", combatMode)
ClickMeForWorkMassProspectingLegion:SetScript("OnEvent", combatMode)
ClickMeForWorkMassMillingAzeroth:SetScript("OnEvent", combatMode)
ClickMeForWorkMassProspectingAzeroth:SetScript("OnEvent", combatMode)

-- Create macro
ClickMeForWorkDisenchanting:SetScript("PreClick", preClickMacroButton)
ClickMeForWorkMilling:SetScript("PreClick", preClickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PreClick", preClickMacroButtonProspecting)
ClickMeForWorkMassMillingLegion:SetScript("PreClick", preClickMacroButtonMassMillingLegion)
ClickMeForWorkMassProspectingLegion:SetScript("PreClick", preClickMacroButtonMassProspectingLegion)
ClickMeForWorkMassMillingAzeroth:SetScript("PreClick", preClickMacroButtonMassMillingAzeroth)
ClickMeForWorkMassProspectingAzeroth:SetScript("PreClick", preClickMacroButtonMassProspectingAzeroth)

-- Clear macro
ClickMeForWorkDisenchanting:SetScript("PostClick", postClickMacroButton)
ClickMeForWorkMilling:SetScript("PostClick", postClickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PostClick", postClickMacroButtonProspecting)
ClickMeForWorkMassMillingLegion:SetScript("PostClick", postClickMacroButtonMassMillingLegion)
ClickMeForWorkMassProspectingLegion:SetScript("PostClick", postClickMacroButtonMassProspectingLegion)
ClickMeForWorkMassMillingAzeroth:SetScript("PostClick", postClickMacroButtonMassMillingAzeroth)
ClickMeForWorkMassProspectingAzeroth:SetScript("PostClick", postClickMacroButtonMassProspectingAzeroth)

function DestroyusProMain.isItemDisenchantableInBag(i, j)
	return DestroyusProMain.isItemDisenchantable(i, j)
end

function DestroyusProMain.isItemMillingableInBag(i, j)
	return DestroyusProMain.isItemMillingable(i, j)
end

function DestroyusProMain.isItemProspectingableInBag(i, j)
	return DestroyusProMain.isItemProspectingable(i, j)
end

DestroyusProMain.isItemProffesionInBag = {}
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellDisenchant] = DestroyusProMain.isItemDisenchantableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellMilling ] = DestroyusProMain.isItemMillingableInBag
DestroyusProMain.isItemProffesionInBag[_DPSpellApi.spellProspecting] = DestroyusProMain.isItemProspectingableInBag

function DestroyusProMain.findItemToWork(proffesion)
    local result = {itemFound=false, i=0 ,j=0, link=_DPContainerItemApi.unknowLink}
	--for i = REAGENTBANK_CONTAINER, (NUM_BAG_SLOTS + NUM_BANKBAGSLOTS) do -- -3, 11
	for i = 0, NUM_BAG_SLOTS do
		for j = 1, GetContainerNumSlots(i) do 
			if DestroyusProMain.isItemProffesionInBag[proffesion](i,j) then
				DestroyusProMain.cif:setItemPos(i, j)
				result["itemFound"] = true
				result["i"] = i
				result["j"] = j
				result["link"] = DestroyusProMain.cif:getLink()
				break
			end 
		end 
	end
	return result
end

-- Create macro string for profession 
function DestroyusProMain.createMacroUsage(spell_id, result)
	local macroStr = ""
	if result["itemFound"] then
		local spellName = _DPSpellApi(spell_id):getSpellName()
		local bagIndex = ""
		if result["i"] == BANK_CONTAINER then
			bagIndex = tostring((DestroyusProMain.basicBankSlotNumIndex-1)+result["j"]) -- /use #
		elseif result["i"] == REAGENTBANK_CONTAINER then
			bagIndex = tostring((DestroyusProMain.reagentBankSlotNumIndex-1)+result["j"]) -- /use #
		else
			bagIndex = string.format("%d %d", result["i"], result["j"]) -- /use # #
		end
		macroStr = string.format("/cast %s\n/use %s", spellName, bagIndex)
		DestroyusProMain.itemFoundAndWorkStarted = true -- Move this line from creating macro function
	end
	return macroStr
end

-- Print results of the destroyed item from the bag
function DestroyusProMain.printResults(spell_id, result)
	local spellName = _DPSpellApi(spell_id):getSpellName()
	if result["itemFound"] then
		_DPInformationPrint("".. spellName .." => " .. result["link"])
	else
		local msg = ""
		if spell_id == _DPSpellApi.spellDisenchant then
			msg = msg .. prettyLoadQuality()
		end
		_DPInformationPrint(string.format("Nothing to %s! %s", spellName, msg))
	end
end

function DestroyusProMain.isItemDisenchantable(i, j)
	return DestroyusPro:isItemDisenchantable(i, j)
end

function DestroyusProMain.isItemMillingable(i, j)
	return DestroyusPro:isItemMillingable(i, j)
end

function DestroyusProMain.isItemProspectingable(i, j)
	return DestroyusPro:isItemProspectingable(i, j)
end

function DestroyusProMain.changeStateForPrintout(state)
	_G["DestroyusProPrintOutState"] = state
end

function DestroyusProMain.changeQualityDisenchanting(quality, value)
	_G["DestroyusProItemQualityValue"][quality] = value
end

-- Frame Manager For Looting after Destroyuspro work
DestroyusProMain.lootManagerFrame = CreateFrame("Frame", "DestroyusProLootManagerFrame")
DestroyusProMain.lootManagerFrame:RegisterEvent("LOOT_OPENED")
DestroyusProMain.lootManagerFrame:RegisterEvent("LOOT_CLOSED")

DestroyusProMain.spellActionFrame = CreateFrame("Frame", "DestroyusProSpellActionFrame")
DestroyusProMain.spellActionFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
DestroyusProMain.spellActionFrame:RegisterEvent("UNIT_SPELLCAST_START")
DestroyusProMain.spellActionFrame:RegisterEvent("UNIT_SPELLCAST_FAILED")
DestroyusProMain.spellActionFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")

function DestroyusProMain.DestroyusProLootAfterIsDPSkill(spellId)
      local result = false
      if _DPSpellApi.spellMilling == spellId or
         _DPSpellApi.spellDisenchant == spellId or
         _DPSpellApi.spellProspecting == spellId then
		 result = true
	  end
	  return result
end

function DestroyusProMain.spellActions(self, event, unitTarget, castGUID, spellID)
    -- Check if spell from DestroyusPro are invoke with successfully
	-- Add protection flag for not invoking more pressing attempts on the macro buttons
	
	if DestroyusProMain.itemFoundAndWorkStarted == false then
		return nil
	end
	if unitTarget ~= "player" then
		return nil
	end

	if event == "UNIT_SPELLCAST_START" and DestroyusProMain.DestroyusProLootAfterIsDPSkill(spellID) then
		-- Disable work flag
		DestroyusProMain.buttonCanWorkEnable = false
	    return nil
	end

    -- Spell Cast was successfull. Flag with item found is cleared and loot flag is set to true
	-- Second flag will allow collect loot during event with loot
	if event == "UNIT_SPELLCAST_SUCCEEDED" and DestroyusProMain.DestroyusProLootAfterIsDPSkill(spellID) then
		DestroyusProMain.itemFoundAndWorkStarted = false
	    DestroyusProMain.canLootItemsAfterWork = true
	    return nil
	end
	
    -- Spell Cast was failed or become interrupted. Flag with item found and loot flag is cleared.
	-- Protection flag for invoking press is enabled 
	if (event == "UNIT_SPELLCAST_INTERRUPTED" or event == "UNIT_SPELLCAST_FAILED") and 
	   DestroyusProMain.DestroyusProLootAfterIsDPSkill(spellID) then
	    DestroyusProMain.itemFoundAndWorkStarted = false
		DestroyusProMain.canLootItemsAfterWork = false
		-- Disable work
		DestroyusProMain.buttonCanWorkEnable = true
		return nil
	end
end

function DestroyusProMain.lootAfterWork(self, event, autoLoot)
	-- Spell Cast was failed or become interrupted. Flag with loot is cleared.
	-- Protection flag for invoking press is enabled
	-- Ignore autoLoot
	if DestroyusProMain.canLootItemsAfterWork and event == "LOOT_OPENED" then
		DestroyusProMain.lootItemsAfterWork()
		DestroyusProMain.canLootItemsAfterWork = false
		return nil
	end

	-- In case of the strange behaves all flags are set to thier defaults behaves
	-- when loot is closed
	if event == "LOOT_CLOSED" then
		DestroyusProMain.itemFoundAndWorkStarted = false
		DestroyusProMain.canLootItemsAfterWork = false
		-- Disable work
		DestroyusProMain.buttonCanWorkEnable = true
	end
end

function DestroyusProMain.lootItemsAfterWork()
	for i = 1, GetNumLootItems() do 
	    LootSlot(i)
	end
end

DestroyusProMain.lootManagerFrame:SetScript("OnEvent", DestroyusProMain.lootAfterWork)
DestroyusProMain.spellActionFrame:SetScript("OnEvent", DestroyusProMain.spellActions)
---  End of Looter

DestroyusProMain.collectMassSpellsFrame = CreateFrame("Frame", "DestroyusProCollectMassSpellsFrame")
DestroyusProMain.collectMassSpellsFrame:RegisterEvent("TRADE_SKILL_DATA_SOURCE_CHANGED")

function DestroyusProMain.collectMassSpells(self, event)
	if DestroyusProMain.calibrationStarted and event == "TRADE_SKILL_DATA_SOURCE_CHANGED" then
		DestroyusPro.ts:collectAllMassSpells()
		if (DestroyusPro.sp:getSkillId() == _DPProfessionApi.skilInscription or 
		   DestroyusPro.sp:getSkillId() == _DPProfessionApi.skillJewelcrafting) and DestroyusProMain.calibrationOngoing == false then
		   DestroyusProMain.calibrationOngoing = true -- Calibration for second profession is ongoing
		   DestroyusPro.ts:openTradeSkill(DestroyusPro.sp:getSkillId())
		else
			DestroyusProMain.calibrationStarted = false
			DestroyusProMain.calibrationOngoing = false
			DestroyusPro.ts:closeTradeSkill()
		end
	end
end

DestroyusProMain.collectMassSpellsFrame:SetScript("OnEvent", DestroyusProMain.collectMassSpells)

function DestroyusProMain.startCalibration(self)
	DestroyusProMain.calibrationStarted = false
	DestroyusProMain.calibrationOngoing = false
	if DestroyusPro.fp:getSkillId() == _DPProfessionApi.skilInscription or 
	   DestroyusPro.fp:getSkillId() == _DPProfessionApi.skillJewelcrafting then
	   DestroyusProMain.calibrationStarted = true
	   DestroyusPro.ts:openTradeSkill(DestroyusPro.fp:getSkillId())
	elseif DestroyusPro.sp:getSkillId() == _DPProfessionApi.skilInscription or 
		   DestroyusPro.sp:getSkillId() == _DPProfessionApi.skillJewelcrafting then
		   DestroyusProMain.calibrationStarted = true
		   DestroyusProMain.calibrationOngoing = true -- Calibration for second profession is ongoing
		   DestroyusPro.ts:openTradeSkill(DestroyusPro.sp:getSkillId())
 	end
end

function _DPInformationPrint(text)
	if _G["DestroyusProPrintOutState"] ~= false then
		print(string.format("|CFF18BE00DestroyusPro: |r%s", text))
	end
end

DestroyusProMain.newSpellLearnedFrame = CreateFrame("Frame", "DestroyusProNewSpellLearnedFrame")
DestroyusProMain.newSpellLearnedFrame:RegisterEvent("NEW_RECIPE_LEARNED")

function DestroyusProMain.massSpellLearned(self, event, spellID)
	if event == "NEW_RECIPE_LEARNED" then
		DestroyusPro.ts:newSpellAppear(spellID, _DPSpellApi.spellsMassMillLegion, DestroyusPro.ts.spellsMassMillLegion)
		DestroyusPro.ts:newSpellAppear(spellID, _DPSpellApi.spellsMassProspectingLegion, DestroyusPro.ts.spellsMassProspectingLegion)
		DestroyusPro.ts:newSpellAppear(spellID, _DPSpellApi.spellsMassMillAzeroth, DestroyusPro.ts.spellsMassMillAzeroth)
		DestroyusPro.ts:newSpellAppear(spellID, _DPSpellApi.spellsMassProspectingAzeroth, DestroyusPro.ts.spellsMassProspectingAzeroth)
		_G["DestroyusProSpellsID"]["MillLegion"] = DestroyusPro.ts.spellsMassMillLegion
		_G["DestroyusProSpellsID"]["MillAzeroth"] = DestroyusPro.ts.spellsMassMillAzeroth
		_G["DestroyusProSpellsID"]["ProspectingLegion"] = DestroyusPro.ts.spellsMassProspectingLegion
		_G["DestroyusProSpellsID"]["ProspectingAzeroth"] = DestroyusPro.ts.spellsMassProspectingAzeroth
		return nil
	end
end

DestroyusProMain.newSpellLearnedFrame:SetScript("OnEvent", DestroyusProMain.massSpellLearned)

function DestroyusProMain.resetCounter()
	if DestroyusProMain.massWorkStarted == false then
		DestroyusProMain.counter = 1
		DestroyusProMain.timerCloseTradeSkill = nil
		DestroyusPro.ts:closeTradeSkill()
	end
end

function DestroyusProMain.createMassWork(learnedSpells, profession, printoutSpellID)
	if DestroyusPro.ts:isRecipeRepeating() then
		_DPInformationPrint("Recipe is repeating. Nothing to do.")
		return
	end
	DestroyusPro:countItemToWork()
	spellID, amount = DestroyusPro:selectSpellToCast(learnedSpells)
	if spellID then
		DestroyusPro.ts:openTradeSkill(profession)
		C_TradeSkillUI.SetRecipeRepeatCount(spellID, amount)
		if DestroyusProMain.counter == 1 then
			DestroyusProMain.massWorkStarted = false
			if DestroyusProMain.timerCloseTradeSkill == nil then
				DestroyusProMain.timerCloseTradeSkill = C_Timer.NewTimer(2, DestroyusProMain.resetCounter)
			else
				DestroyusProMain.timerCloseTradeSkill:Cancel()
				DestroyusProMain.timerCloseTradeSkill = C_Timer.NewTimer(2, DestroyusProMain.resetCounter)
			end
		end
		if DestroyusProMain.counter == 2 then
			if TradeSkillFrame then
				TradeSkillFrame:SelectRecipe(spellID)
			end
		end
		if DestroyusProMain.counter == 3 then
			DestroyusProMain.counter = 1
			DestroyusProMain.massWorkStarted = true
			DestroyusProMain.itemFoundAndMassWorkStarted = true
			_DPInformationPrint(string.format("Repeating %s %d times.", _DPSpellApi(spellID):getSpellName(), amount))
			C_TradeSkillUI.CraftRecipe(spellID, amount)
		else
			DestroyusProMain.counter = DestroyusProMain.counter + 1
		end
	else
		_DPInformationPrint(string.format("Nothing to %s!", _DPSpellApi(printoutSpellID):getSpellName()))
	end
	DestroyusPro:clearTableCountItem()
end


function DestroyusProMain.checkIfWorkDone()
	if DestroyusPro.ts:isRecipeRepeating() == false and DestroyusProMain.itemFoundAndMassWorkStarted == true then
		DestroyusProMain.itemFoundAndMassWorkStarted = false
		DestroyusProMain.timerCheckWorkDone = nil
		DestroyusPro.ts:closeTradeSkill()
	end
end

DestroyusProMain.spellMassActionFrame = CreateFrame("Frame", "DestroyusProSpellMassActionFrame")
DestroyusProMain.spellMassActionFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
DestroyusProMain.spellMassActionFrame:RegisterEvent("UNIT_SPELLCAST_START")
DestroyusProMain.spellMassActionFrame:RegisterEvent("UNIT_SPELLCAST_FAILED")
DestroyusProMain.spellMassActionFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")

function DestroyusProMain.spellMassActions(self, event, unitTarget, castGUID, spellID)
    if DestroyusProMain.itemFoundAndMassWorkStarted == false then
		return nil
	end
	if unitTarget ~= "player" then
		return nil
	end

	-- Spell Cast was successfull.
	if event == "UNIT_SPELLCAST_SUCCEEDED" and DestroyusProMain.DestroyusProAfterMassWork(spellID) then
		if DestroyusProMain.timerCheckWorkDone == nil then
			DestroyusProMain.timerCheckWorkDone = C_Timer.NewTimer(0.5, DestroyusProMain.checkIfWorkDone)
		else
			DestroyusProMain.timerCheckWorkDone:Cancel()
			DestroyusProMain.timerCheckWorkDone = C_Timer.NewTimer(0.5, DestroyusProMain.checkIfWorkDone)
		end
		return nil
	end

	-- Spell Cast was failed or become interrupted.
	if (event == "UNIT_SPELLCAST_INTERRUPTED" or event == "UNIT_SPELLCAST_FAILED") and 
	   DestroyusProMain.DestroyusProAfterMassWork(spellID) then
		DestroyusProMain.itemFoundAndMassWorkStarted = false
		DestroyusPro.ts:closeTradeSkill()
		return nil
	end
end

DestroyusProMain.spellMassActionFrame:SetScript("OnEvent", DestroyusProMain.spellMassActions)

function DestroyusProMain.DestroyusProAfterMassWork(spellID)
	local result = false
	if _DPSpellApi.spellMassMillAethril == spellID or
	   _DPSpellApi.spellMassMillDreamleaf == spellID or
	   _DPSpellApi.spellMassMillFelwort == spellID or
	   _DPSpellApi.spellMassMillFjarnskaggl == spellID or
	   _DPSpellApi.spellMassMillFoxflower == spellID or
	   _DPSpellApi.spellMassMillStarlightRose == spellID or
	   _DPSpellApi.spellMassMillYserallineSeeds == spellID or
	   _DPSpellApi.spellMassMillAstralGlory == spellID or
	   _DPSpellApi.spellMassProspectFelslate == spellID or
	   _DPSpellApi.spellMassProspecLeystone == spellID or 
	   _DPSpellApi.spellMassProspectEmpyrium == spellID or 
	   _DPSpellApi.spellMassMillAnchorWeed == spellID or 
	   _DPSpellApi.spellMassMillAkundasBite == spellID or 
	   _DPSpellApi.spellMassMillRiverbud == spellID or 
	   _DPSpellApi.spellMassMillSeaStalk == spellID or 
	   _DPSpellApi.spellMassMillSirensPollen == spellID or 
	   _DPSpellApi.spellMassMillStarMoss == spellID or 
	   _DPSpellApi.spellMassMillWintersKiss == spellID or 
	   _DPSpellApi.spellMassProspectPlatinum == spellID or 
	   _DPSpellApi.spellMassProspecStormSilver == spellID or 
	   _DPSpellApi.spellMassProspectMonelite == spellID then
		result = true
	end
	return result
end
