_DPSpellApi = {}
_DPSpellApi.__index = _DPSpellApi

setmetatable(_DPSpellApi, {
  __call = function (cls, index)
    return cls.new(index)
  end,
})

function _DPSpellApi.new(index)
    local self = setmetatable({}, _DPSpellApi)
    self:_init(index)
    return self
end

function _DPSpellApi._init(self, index)
	self._spellIndex = index
end

function _DPSpellApi.getSpellName(self)
    local spell = select(1, GetSpellInfo(self._spellIndex))
	if spell == nil then
		spell = self.unknowSpellName
	end
	return spell
end

function _DPSpellApi.isInSpellBook(self) 
	local exist = true
	if GetSpellBookItemInfo(self:getSpellName()) == nil then
		exist = false
	end
	return exist
end

_DPSpellApi.unknowSpellId = -1
_DPSpellApi.unknowSpellType = "?Unknow!"
_DPSpellApi.unknowSpellName = "?Unknow!"

_DPSpellApi.spellMilling = 51005
_DPSpellApi.spellDisenchant = 13262
_DPSpellApi.spellProspecting = 31252

-- Legion Mass Milling
_DPSpellApi.spellMassMillAethril = 209658
_DPSpellApi.spellMassMillDreamleaf = 209659
_DPSpellApi.spellMassMillFelwort = 209664
_DPSpellApi.spellMassMillFjarnskaggl = 209661
_DPSpellApi.spellMassMillFoxflower = 209660
_DPSpellApi.spellMassMillStarlightRose = 209662
_DPSpellApi.spellMassMillYserallineSeeds = 210116
_DPSpellApi.spellMassMillAstralGlory = 247861

-- Legion Mass Prospecting
_DPSpellApi.spellMassProspectFelslate = 225904
_DPSpellApi.spellMassProspecLeystone = 225902
_DPSpellApi.spellMassProspectEmpyrium = 247761

-- Battle for Azeroth Mass Milling
_DPSpellApi.spellMassMillAnchorWeed = 256308
_DPSpellApi.spellMassMillAkundasBite = 256219
_DPSpellApi.spellMassMillRiverbud = 256217
_DPSpellApi.spellMassMillSeaStalk = 256223
_DPSpellApi.spellMassMillSirensPollen = 256221
_DPSpellApi.spellMassMillStarMoss = 256218
_DPSpellApi.spellMassMillWintersKiss = 256220

-- Battle for Azeroth Mass Prospecting
_DPSpellApi.spellMassProspectPlatinum = 256622
_DPSpellApi.spellMassProspecStormSilver = 256613
_DPSpellApi.spellMassProspectMonelite = 256611

_DPSpellApi.spellsMassMillLegion = 
	{_DPSpellApi.spellMassMillAethril,
	_DPSpellApi.spellMassMillDreamleaf,
	_DPSpellApi.spellMassMillFelwort,
	_DPSpellApi.spellMassMillFjarnskaggl,
	_DPSpellApi.spellMassMillFoxflower,
	_DPSpellApi.spellMassMillStarlightRose,
	_DPSpellApi.spellMassMillYserallineSeeds,
	_DPSpellApi.spellMassMillAstralGlory}
	
_DPSpellApi.spellsMassProspectingLegion =
	{_DPSpellApi.spellMassProspectFelslate,
	_DPSpellApi.spellMassProspecLeystone,
	_DPSpellApi.spellMassProspectEmpyrium}

_DPSpellApi.spellsMassMillAzeroth = 
	{_DPSpellApi.spellMassMillAnchorWeed,
	_DPSpellApi.spellMassMillAkundasBite,
	_DPSpellApi.spellMassMillRiverbud,
	_DPSpellApi.spellMassMillSeaStalk,
	_DPSpellApi.spellMassMillSirensPollen,
	_DPSpellApi.spellMassMillStarMoss,
	_DPSpellApi.spellMassMillWintersKiss}
	 
_DPSpellApi.spellsMassProspectingAzeroth =
    {_DPSpellApi.spellMassProspectPlatinum,
	_DPSpellApi.spellMassProspecStormSilver,
	_DPSpellApi.spellMassProspectMonelite}
