BattleOfAzerothTest = {}
BattleOfAzerothTest.__index = BattleOfAzerothTest

setmetatable(BattleOfAzerothTest, {
	__index = UnitTest, -- this is what makes the inheritance work
	__call = function (cls)
	  local self = setmetatable({}, cls)
	  UnitTest:_init(self)
	  return self
	end
  })

  function BattleOfAzerothTest.setUp(self)
	self.functionProfInfo = GetProfessionInfo
	self.functionGetProf = GetProfessions
	self.bagFunction =  GetContainerItemInfo
	self.GetContainerNumSlots = GetContainerNumSlots
	---
    GetContainerItemInfo = function(i, j) return bagClass:returnBagSlot(i, j) end
	GetContainerNumSlots = function(i) return bagClass:returnContainerNumSlot(i) end
	_profApi:setFirstProf(INSCRIPTION_LVL367_INDEX1)
	_profApi:setSecondProf(JEWELCRAFTING_LVL125_INDEX2)
	GetProfessions = function() return  _profApi:getProfessions() end
	GetProfessionInfo = function(index) return _profApi:getProfessionInfo(index) end
	DestroyusPro.ts.spellsMassMillLegion = {}
	DestroyusPro.ts.spellsMassProspectingLegion = {}
	DestroyusPro.ts.spellsMassMillAzeroth = {}
	DestroyusPro.ts.spellsMassProspectingAzeroth = {}
	DestroyusPro.ts.openTradeSkill = function() return  true end
	DestroyusPro.ts.closeTradeSkill = function() return  true end
	DestroyusPro.ts.craftRecipe = function() return true end
	DestroyusPro.ts.getRecipeInfo = function(self, spellID)
		result = {}
		result.learned = false
		if spellID == _DPSpellApi.spellMassMillDreamleaf or  spellID == _DPSpellApi.spellMassMillAethril or spellID == _DPSpellApi.spellMassProspectEmpyrium or
		  spellID == _DPSpellApi.spellMassProspecStormSilver or spellID == _DPSpellApi.spellMassMillSirensPollen or spellID == _DPSpellApi.spellMassMillWintersKiss then
		  result.learned = true
		  return result
		end
		return result
	end
end

function BattleOfAzerothTest.tearDown(self)
	GetProfessionInfo = self.functionProfInfo
	GetProfessions = self.functionGetProf
	GetContainerItemInfo = self.bagFunction
	GetContainerNumSlots = self.GetContainerNumSlots
	DestroyusPro.ts.spellsMassMillLegion = {}
	DestroyusPro.ts.spellsMassProspectingLegion = {}
	DestroyusPro.ts.spellsMassMillAzeroth = {}
	DestroyusPro.ts.spellsMassProspectingAzeroth = {}
end

function BattleOfAzerothTest.buildTestForCountItemToWorkMassProf(self, item, name)
	bagClass:setBagSlot(item)
	DestroyusPro:countItemToWork()
	self:assertEquals(DestroyusPro.countItem[item["itemId"]],
	item["count"], name .. " => Wrong counting number")
end

function BattleOfAzerothTest.clearTableCountItem(self)
	DestroyusPro:clearTableCountItem()
	for key in pairs(DestroyusPro.countItem) do
		self:assertEquals(DestroyusPro.countItem[key], 0,
						  string.format("%d have different value %d than 0",
						                key, DestroyusPro.countItem[key]))
	end
end

function BattleOfAzerothTest.buildTestForCountItemMultiple(self, first, second)
	bagClass:setBagSlot(first)
	DestroyusPro:countHerbAndOreMass(first["i"], first["j"])
	bagClass:setBagSlot(second)
	DestroyusPro:countHerbAndOreMass(second["i"], second["j"])
	bagClass:setBagSlot(first)
	DestroyusPro:countHerbAndOreMass(first["i"], first["j"])
	bagClass:setBagSlot(second)
	DestroyusPro:countHerbAndOreMass(second["i"], second["j"])
	self:assertEquals(DestroyusPro.countItem[first["itemId"]],
	first["count"] * 2, "Adding dont work")
	self:assertEquals(DestroyusPro.countItem[second["itemId"]],
	second["count"] * 2, "Adding dont work")
	self:clearTableCountItem()
end

function BattleOfAzerothTest.buildTestForSelectSpellToCast(self, item, spells, spellID, name)
	self:buildTestForCountItemToWorkMassProf(item, name)
	spell, amount = DestroyusPro:selectSpellToCast(spells)
	self:clearTableCountItem()
	self:assertEquals(spell, spellID, string.format("Wrong SpellID %s. Should be %d for %s", tostring(spell), spellID, name))
	if spellID ~= nil then
		self:assertEquals(amount, floor(item["count"] / DestroyusPro.minRequireAmountInStackForMasWork), string.format("Wrong amount of crafting stack %d for %s", amount, name))
	end
end

function BattleOfAzerothTest.test_countItemToWorkMilling(self)
	self:buildTestForCountItemToWorkMassProf(ANCHOR_WEED_COUNT20_3_12, "Anchor Weed")
	self:buildTestForCountItemToWorkMassProf(RIVERBUD_COUNT20_3_12, "Riverbud")
	self:buildTestForCountItemToWorkMassProf(STAR_MOSE_COUNT20_3_12, "Star Mose")
	self:buildTestForCountItemToWorkMassProf(AKUNDAS_BITE_COUNT20_3_12, "Akunda's Bite")
	self:buildTestForCountItemToWorkMassProf(WINTER_KISS_COUNT20_3_12, "Winter Kiss")
	self:buildTestForCountItemToWorkMassProf(SIRENS_POLLEN_COUNT20_3_12, "Siren's Pollen")
	self:buildTestForCountItemToWorkMassProf(SEA_STALK_COUNT20_3_12, "Sea Stalk")
	self:clearTableCountItem()
end

function BattleOfAzerothTest.test_countItemToWorkProspecting(self)
	self:buildTestForCountItemToWorkMassProf(STORM_SILVER_ORE_COUNT20_3_12, "Storm Silver Ore")
	self:buildTestForCountItemToWorkMassProf(MONELITE_ORE_COUNT20_3_12, "Monelite Ore")
	self:buildTestForCountItemToWorkMassProf(PLATINIUM_ORE_COUNT20_3_12, "Platinium Ore")
	self:clearTableCountItem()
end

function BattleOfAzerothTest.test_countHerbAndOreMassMultiple(self)
	self:buildTestForCountItemMultiple(STARLIGHT_ROSE_COUNT20_3_12,
									   PLATINIUM_ORE_COUNT20_3_12)
end

function BattleOfAzerothTest.test_selectSpellToCastMillingPositive(self)
	self:buildTestForSelectSpellToCast(ANCHOR_WEED_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillAnchorWeed, "Anchor Weed")
	self:buildTestForSelectSpellToCast(RIVERBUD_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillRiverbud, "Riverbud")
	self:buildTestForSelectSpellToCast(STAR_MOSE_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillStarMoss, "Star Mose")
	self:buildTestForSelectSpellToCast(AKUNDAS_BITE_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillAkundasBite, "Akunda's Bite")
	self:buildTestForSelectSpellToCast(WINTER_KISS_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillWintersKiss, "Winter Kiss")
	self:buildTestForSelectSpellToCast(SIRENS_POLLEN_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillSirensPollen, "Siren's Pollen")
	self:buildTestForSelectSpellToCast(SEA_STALK_COUNT20_3_12, SPELLS_ALL_MILLING_AZEROTH, _DPSpellApi.spellMassMillSeaStalk, "Sea Stalk")
end

function BattleOfAzerothTest.test_selectSpellToCastMillingNegative(self)
	self:buildTestForSelectSpellToCast(ANCHOR_WEED_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Aerhril")
	self:buildTestForSelectSpellToCast(RIVERBUD_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Dreamleaf")
	self:buildTestForSelectSpellToCast(STAR_MOSE_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Felwort")
	self:buildTestForSelectSpellToCast(AKUNDAS_BITE_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Fjarnskaggl")
	self:buildTestForSelectSpellToCast(WINTER_KISS_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Foxflower")
	self:buildTestForSelectSpellToCast(SIRENS_POLLEN_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Starlight Rose")
	self:buildTestForSelectSpellToCast(SEA_STALK_COUNT19_3_12, SPELLS_ALL_MILLING_AZEROTH, nil, "Yseralline Seed")
end

function BattleOfAzerothTest.test_selectSpellToCastProspectingPositive(self)
	self:buildTestForSelectSpellToCast(STORM_SILVER_ORE_COUNT20_3_12, SPELLS_ALL_PROSPECTING_AZEROTH, _DPSpellApi.spellMassProspecStormSilver, "Storm Silver Ore")
	self:buildTestForSelectSpellToCast(MONELITE_ORE_COUNT20_3_12, SPELLS_ALL_PROSPECTING_AZEROTH, _DPSpellApi.spellMassProspectMonelite, "Monelite Ore")
	self:buildTestForSelectSpellToCast(PLATINIUM_ORE_COUNT20_3_12, SPELLS_ALL_PROSPECTING_AZEROTH, _DPSpellApi.spellMassProspectPlatinum, "Platinium Ore")
end

function BattleOfAzerothTest.test_selectSpellToCastProspectingNegative(self)
	self:buildTestForSelectSpellToCast(STORM_SILVER_ORE_COUNT19_3_12, SPELLS_ALL_PROSPECTING_AZEROTH, nil, "Storm Silver Ore")
	self:buildTestForSelectSpellToCast(MONELITE_ORE_COUNT19_3_12, SPELLS_ALL_PROSPECTING_AZEROTH, nil, "Monelite Ore")
	self:buildTestForSelectSpellToCast(PLATINIUM_ORE_COUNT19_3_12, SPELLS_ALL_PROSPECTING_AZEROTH, nil, "Platinium Ore")
end

function BattleOfAzerothTest.test_selectSpellToCastPartial(self)
	self:buildTestForSelectSpellToCast(AKUNDAS_BITE_COUNT20_3_12, SPELLS_AKUNDESBITE_SEASTALK_WINTERKISS_PLATINUM_MONELITE, _DPSpellApi.spellMassMillAkundasBite, "Akunda's Bite")
	self:buildTestForSelectSpellToCast(ANCHOR_WEED_COUNT20_3_12, SPELLS_AKUNDESBITE_SEASTALK_WINTERKISS_PLATINUM_MONELITE, nil, "Anchor Weed")
	self:buildTestForSelectSpellToCast(MONELITE_ORE_COUNT20_3_12, SPELLS_AKUNDESBITE_SEASTALK_WINTERKISS_PLATINUM_MONELITE, _DPSpellApi.spellMassProspectMonelite, "Monelite Ore")
end

function BattleOfAzerothTest.buildIsSpellLearned(self, spellID, spells, learned)
	if learned then
		self:assertEquals(DestroyusPro.ts:isSpellLearned(spellID, spells), learned, string.format("Spell %s, Should be added to elements of table", _DPSpellApi(spellID):getSpellName()))
	else
		self:assertEquals(DestroyusPro.ts:isSpellLearned(spellID, spells), learned, string.format("Spell %s, Already exisit in the table with elements", _DPSpellApi(spellID):getSpellName()))
	end
end

function BattleOfAzerothTest.buildMassSpellLearned(self, spellsToLearn, spellsLearned, elements, extraSpellID)
	for key, spellID in ipairs(spellsToLearn) do
		self:buildIsSpellLearned(spellID, spellsLearned, false)
	end
	self:assertEquals(table.getn(spellsLearned), 0, "Table size should be 0")

	for key, spellID in ipairs(spellsToLearn) do
		DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_LEARNED", spellID)
		self:buildIsSpellLearned(spellID, spellsLearned, true)
	end

	DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_LEARNED", _DPSpellApi.unknowSpellId)
	DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_WRONG_EVENT", extraSpellID)
	DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_LEARNED", extraSpellID)
	self:buildIsSpellLearned(_DPSpellApi.unknowSpellId, spellsLearned, false)
	self:assertEquals(table.getn(spellsLearned), elements, "Table size should be 8")
end

function BattleOfAzerothTest.test_collectMassSpells(self)
	DestroyusPro.ts:collectAllMassSpells()
	self:buildIsSpellLearned(_DPSpellApi.spellMassProspecStormSilver, DestroyusPro.ts.spellsMassProspectingAzeroth, true)
	self:buildIsSpellLearned(_DPSpellApi.spellMassProspectPlatinum, DestroyusPro.ts.spellsMassProspectingAzeroth, false)
	self:buildIsSpellLearned(_DPSpellApi.spellMassMillSirensPollen, DestroyusPro.ts.spellsMassMillAzeroth, true)
	self:buildIsSpellLearned(_DPSpellApi.spellMassMillWintersKiss, DestroyusPro.ts.spellsMassMillAzeroth, true)
	self:buildIsSpellLearned(_DPSpellApi.spellMassMillStarMoss, DestroyusPro.ts.spellsMassMillAzeroth, false)
end

function BattleOfAzerothTest.test_massSpellLearned(self)
	self:buildMassSpellLearned(_DPSpellApi.spellsMassMillAzeroth, DestroyusPro.ts.spellsMassMillAzeroth, 7, _DPSpellApi.spellMassMillAnchorWeed)
	self:buildMassSpellLearned(_DPSpellApi.spellsMassProspectingAzeroth, DestroyusPro.ts.spellsMassProspectingAzeroth, 3, _DPSpellApi.spellMassProspecStormSilver)
end