HerbsAndOresTest = {}
HerbsAndOresTest.__index = HerbsAndOresTest

setmetatable(HerbsAndOresTest, {
  __index = UnitTest, -- this is what makes the inheritance work
  __call = function (cls)
    local self = setmetatable({}, cls)
    UnitTest:_init(self)
    return self
  end
})

function HerbsAndOresTest.setUp(self)
	self.bagFunction =  GetContainerItemInfo
	self.functionProfInfo = GetProfessionInfo
	self.functionGetProf = GetProfessions
	self.GetContainerNumSlots = GetContainerNumSlots
	---- 
	_profApi:setFirstProf(INSCRIPTION_LVL367_INDEX1)
	_profApi:setSecondProf(JEWELCRAFTING_LVL125_INDEX2)
	GetProfessions = function() return  _profApi:getProfessions() end
	GetProfessionInfo = function(index) return _profApi:getProfessionInfo(index) end
	GetContainerItemInfo = function(i, j) return bagClass:returnBagSlot(i, j) end
	GetContainerNumSlots = function(i) return bagClass:returnContainerNumSlot(i) end
    self.itemApi = _DPContainerItemApi()
end

function HerbsAndOresTest.tearDown(self)
	GetProfessionInfo = self.functionProfInfo
	GetProfessions = self.functionGetProf
	GetContainerItemInfo = self.bagFunction
	GetContainerNumSlots = self.GetContainerNumSlots
end

function HerbsAndOresTest.test_requiredStackAmountForMillingProspecting(self)					  
	bagClass:setBagSlot(MANA_THISTL_COUNT5_2_9)
	self.itemApi:setItemPos(MANA_THISTL_COUNT5_2_9["i"], MANA_THISTL_COUNT5_2_9["j"])
    self:assertEquals(DestroyusPro:isStackAmountEnough(self.itemApi:getStackSize()), 
	                  true, "Stack 5 should be enough")

	bagClass:setBagSlot(TIN_ORE_COUNT4_2_5)
	self.itemApi:setItemPos(TIN_ORE_COUNT4_2_5["i"], TIN_ORE_COUNT4_2_5["j"])					  
    self:assertEquals(DestroyusPro:isStackAmountEnough(self.itemApi:getStackSize()),
	                  false, "Stack 4 should not be enough")
					  
    bagClass:setBagSlot(FEDELEAF_COUNT6_2_9)
	self.itemApi:setItemPos(FEDELEAF_COUNT6_2_9["i"], FEDELEAF_COUNT6_2_9["j"])
    self:assertEquals(DestroyusPro:isStackAmountEnough(self.itemApi:getStackSize()),
	                  true, "Stack 6 should be enough")
end

function HerbsAndOresTest.test_isHerb(self)
    bagClass:setBagSlot(FEDELEAF_COUNT6_2_9)
	self.itemApi:setItemPos(FEDELEAF_COUNT6_2_9["i"], FEDELEAF_COUNT6_2_9["j"])
    self:assertEquals(DestroyusPro:isHerb(self.itemApi:getItemClassId(),
           	          self.itemApi:getItemSubClassId()), true, "Case 1")
	
	bagClass:setBagSlot(COPPER_ORE_COUNT5_1_1)
	self.itemApi:setItemPos(COPPER_ORE_COUNT5_1_1["i"], COPPER_ORE_COUNT5_1_1["j"])
    self:assertEquals(DestroyusPro:isHerb(self.itemApi:getItemClassId(),
	                  self.itemApi:getItemSubClassId()), false, "Case 2")
	
	bagClass:setBagSlot(FILTHY_PAW_FIST_WEAPON_1_1)
    self.itemApi:setItemPos(FILTHY_PAW_FIST_WEAPON_1_1["i"], FILTHY_PAW_FIST_WEAPON_1_1["j"])
    self:assertEquals(DestroyusPro:isHerb(self.itemApi:getItemClassId(),
                      self.itemApi:getItemSubClassId()), false, "Case 3")
end

function HerbsAndOresTest.test_isOre(self)
	bagClass:setBagSlot(THORIUM_ORE_COUNT20_1_10)
    self.itemApi:setItemPos(THORIUM_ORE_COUNT20_1_10["i"], THORIUM_ORE_COUNT20_1_10["j"])
    self:assertEquals(DestroyusPro:isOre(self.itemApi:getItemClassId(),
	                  self.itemApi:getItemSubClassId(),
                      self.itemApi:getItemId()), true)
	
	-- Is Metal and Trade good. Not ore
	bagClass:setBagSlot(COPPER_BAR_COUNT50_1_1)
    self.itemApi:setItemPos(COPPER_BAR_COUNT50_1_1["i"], COPPER_BAR_COUNT50_1_1["j"])	
    self:assertEquals(DestroyusPro:isOre(self.itemApi:getItemClassId(),
	                  self.itemApi:getItemSubClassId(),
                      self.itemApi:getItemId()), false)
										 
	bagClass:setBagSlot(GHOST_IRON_ORE_COUNT5_1_1)
    self.itemApi:setItemPos(GHOST_IRON_ORE_COUNT5_1_1["i"], GHOST_IRON_ORE_COUNT5_1_1["j"])
    self:assertEquals(DestroyusPro:isOre(self.itemApi:getItemClassId(),
	                  self.itemApi:getItemSubClassId(),
                      self.itemApi:getItemId()), true)
		
	bagClass:setBagSlot(RAZORWIND_MACE_ONE_HAND_MACE_1_1)
    self.itemApi:setItemPos(RAZORWIND_MACE_ONE_HAND_MACE_1_1["i"], RAZORWIND_MACE_ONE_HAND_MACE_1_1["j"])										 
    self:assertEquals(DestroyusPro:isOre(self.itemApi:getItemClassId(),
	                  self.itemApi:getItemSubClassId(),
                      self.itemApi:getItemId()), false)
end

function HerbsAndOresTest.test_herbQualityAllowed(self)
    self:assertEquals(DestroyusPro:isQualityHerbAllowed(1), 
	                  true, "Quality 1 should be allowed")
    self:assertEquals(DestroyusPro:isQualityHerbAllowed(2),
	                  true, "Quality 2 should be allowed")
    self:assertEquals(DestroyusPro:isQualityHerbAllowed(0),
	                  false, "Quality 0 should not be allowed")
    self:assertEquals(DestroyusPro:isQualityHerbAllowed(3),
	                  false, "Quality 3 should be allowed")
end

function HerbsAndOresTest.test_isItemNotConsumable(self)
    -- Item is Herb. Consumable
	bagClass:setBagSlot(BROKEN_FROSTWEED_STEAM_COUNT50_2_3)
    self.itemApi:setItemPos(BROKEN_FROSTWEED_STEAM_COUNT50_2_3["i"],
	                        BROKEN_FROSTWEED_STEAM_COUNT50_2_3["j"])
    self:assertEquals(DestroyusPro:isItemNotConsumable(self.itemApi:getItemId()), 
	                  false, "Items should not be consumable case 1") 
					  
    -- Item is Herb. Not Consumable
	bagClass:setBagSlot(FIREWEED_COUNT4_1_1)
    self.itemApi:setItemPos(FIREWEED_COUNT4_1_1["i"],
	                        FIREWEED_COUNT4_1_1["j"])
    self:assertEquals(DestroyusPro:isItemNotConsumable(self.itemApi:getItemId()), 
	                  true, "Items should be consumable case 2")
					  
    -- Item is Herb. Consumable
	bagClass:setBagSlot(ADDER_TONGUE_STEAM_COUNT50_3_1)
    self.itemApi:setItemPos(ADDER_TONGUE_STEAM_COUNT50_3_1["i"],
	                        ADDER_TONGUE_STEAM_COUNT50_3_1["j"])
    self:assertEquals(DestroyusPro:isItemNotConsumable(self.itemApi:getItemId()), 
	                  false, "Items should not be consumable case 3")
					  
    -- Item is Herb. Not Consumable
	bagClass:setBagSlot(SNOW_LILY_COUNT5_1_1)
    self.itemApi:setItemPos(SNOW_LILY_COUNT5_1_1["i"],
	                        SNOW_LILY_COUNT5_1_1["j"])
    self:assertEquals(DestroyusPro:isItemNotConsumable(self.itemApi:getItemId()), 
	                  true, "Items should be consumable case 4")
end

function HerbsAndOresTest.test_haveItemRequiredProfLvl(self)
	-- Gromsblood
	bagClass:setBagSlot(GROMSBLOOD_COUNT10_1_1)
    self.itemApi:setItemPos(GROMSBLOOD_COUNT10_1_1["i"],
	                        GROMSBLOOD_COUNT10_1_1["j"])
    self:assertEquals(DestroyusPro:haveItemRequiredProfLvl(
	    self.itemApi:getItemId(),
        _DPProfessionApi.skilInscription, DestroyusPro.herbsIlvl),
		true, "Gromsblood should have required prof lvl")
		
	-- Snow Lily
	bagClass:setBagSlot(SNOW_LILY_COUNT5_1_1)
    self.itemApi:setItemPos(SNOW_LILY_COUNT5_1_1["i"],
	                        SNOW_LILY_COUNT5_1_1["j"])
    self:assertEquals(DestroyusPro:haveItemRequiredProfLvl(
		self.itemApi:getItemId(),
        _DPProfessionApi.skilInscription, DestroyusPro.herbsIlvl),
		true, "Snow Lily should  have required prof lvl") 
		
	-- Fireweed
	bagClass:setBagSlot(FIREWEED_COUNT10_1_1)
    self.itemApi:setItemPos(FIREWEED_COUNT10_1_1["i"],
	                        FIREWEED_COUNT10_1_1["j"])
    self:assertEquals(DestroyusPro:haveItemRequiredProfLvl(
		self.itemApi:getItemId(),
        _DPProfessionApi.skilInscription, DestroyusPro.herbsIlvl),
		true, "Fireweed should have required prof lvl")
		
	-- Starlight Rose
	bagClass:setBagSlot(STARLIGHT_ROSE_COUNT20_3_12)
    self.itemApi:setItemPos(STARLIGHT_ROSE_COUNT20_3_12["i"],
	                        STARLIGHT_ROSE_COUNT20_3_12["j"])
    self:assertEquals(DestroyusPro:haveItemRequiredProfLvl(
        self.itemApi:getItemId(),
        _DPProfessionApi.skilInscription, DestroyusPro.herbsIlvl),
		true, "Starlight should have required prof lvl")
	
	-- Razorwind mace
	bagClass:setBagSlot(RAZORWIND_MACE_ONE_HAND_MACE_1_1)
    self.itemApi:setItemPos(RAZORWIND_MACE_ONE_HAND_MACE_1_1["i"],
	                        RAZORWIND_MACE_ONE_HAND_MACE_1_1["j"])
    self:assertEquals(DestroyusPro:haveItemRequiredProfLvl(
	    self.itemApi:getItemId(),
        _DPProfessionApi.skilInscription, DestroyusPro.herbsIlvl),
		false, "Razorwind mace should not have required prof lvl")
end

function HerbsAndOresTest.test_isNotUniqueItem(self)
    -- Herb is in unique list
	bagClass:setBagSlot(WILDVINE_COUNT20_2_2)
    self.itemApi:setItemPos(WILDVINE_COUNT20_2_2["i"],
	                        WILDVINE_COUNT20_2_2["j"])
	self:assertEquals(DestroyusPro:isNotUniqueItem(self.itemApi:getItemId(),
	                  DestroyusPro.itemsIdNotForMilling), 
	                  false, "Items should be unique!")
			
    -- Herb is in not on the unique list			
	bagClass:setBagSlot(SNOW_LILY_COUNT5_1_1)
    self.itemApi:setItemPos(SNOW_LILY_COUNT5_1_1["i"],
	                        SNOW_LILY_COUNT5_1_1["j"])
	self:assertEquals(DestroyusPro:isNotUniqueItem(self.itemApi:getItemId(),
	                  DestroyusPro.itemsIdNotForMilling),
	                  true, "Items should not be unique!")
end

function HerbsAndOresTest.test_isItemNotSellable(self)
	-- Item is not for sell 
	self:assertEquals(DestroyusPro:isItemNotSellable(true),
	                  false, "Item should be unique and not for sell")
	-- Item is for sell
	self:assertEquals(DestroyusPro:isItemNotSellable(false),
	                  true, "Item should be unique and can be sold")
end

function HerbsAndOresTest.test_isItemMillingable(self)
	-- Herb which can be millingable
	bagClass:setBagSlot(SNOW_LILY_COUNT5_1_1)
    self.itemApi:setItemPos(SNOW_LILY_COUNT5_1_1["i"],
	                        SNOW_LILY_COUNT5_1_1["j"])
	self:assertEquals(DestroyusPro:isItemMillingable(SNOW_LILY_COUNT5_1_1["i"],
	                  SNOW_LILY_COUNT5_1_1["j"]),
	                  true, "Herb can be millingable")
					  
	-- Stack size good and herb is millingable
	bagClass:setBagSlot(FIREWEED_COUNT10_1_1)
	self:assertEquals(DestroyusPro:isItemMillingable(FIREWEED_COUNT10_1_1["i"],
	                  FIREWEED_COUNT10_1_1["j"]),
	                  true, "Stack size bad or herb is not millingable")
					  
	-- Stack size small when herb is millingable
	bagClass:setBagSlot(FIREWEED_COUNT4_1_1)
	self:assertEquals(DestroyusPro:isItemMillingable(FIREWEED_COUNT4_1_1["i"],
	                  FIREWEED_COUNT4_1_1["j"]),
	                  false, "Stack size should be 4 < 5!")  
					  
	-- Lvl of prof skill is better than herb
	bagClass:setBagSlot(GROMSBLOOD_COUNT10_1_1)
	self:assertEquals(DestroyusPro:isItemMillingable(GROMSBLOOD_COUNT10_1_1["i"],
	                  GROMSBLOOD_COUNT10_1_1["j"]),
	                  true, "Skill lvl is lover than herb lvl")
					  
	-- Lvl of prof skill is better than herb
	bagClass:setBagSlot(CINDERBLOOM_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemMillingable(CINDERBLOOM_COUNT5_1_1["i"],
	                  CINDERBLOOM_COUNT5_1_1["j"]),
	                  true, "Herb can not be milled in current prof lvl")
					  
	-- Item is not herb
	bagClass:setBagSlot(COPPER_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemMillingable(COPPER_ORE_COUNT5_1_1["i"],
	                  COPPER_ORE_COUNT5_1_1["j"]),
	                  false, "Item is not a herb!")
					  
	-- Stack size good and herb is millingable. uncommon quality felwort
	bagClass:setBagSlot(FELWORT_COUNT10_1_1)
	self:assertEquals(DestroyusPro:isItemMillingable(FELWORT_COUNT10_1_1["i"],
	                  FELWORT_COUNT10_1_1["j"]), true,
					  "Felwort uncommon quality should be selected as ok")
					  
	-- Stack size good and herb is millingable. uncommon quality felwort
	bagClass:setBagSlot(ASTRAL_GLORY_COUNT20_3_10)
	self:assertEquals(DestroyusPro:isItemMillingable(ASTRAL_GLORY_COUNT20_3_10["i"],
	                  ASTRAL_GLORY_COUNT20_3_10["j"]), true,
					  "Felwort uncommon quality should be selected as ok")
end

function HerbsAndOresTest.test_isItemProspectingable(self)
	-- Copper Ore
	bagClass:setBagSlot(COPPER_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(COPPER_ORE_COUNT5_1_1["i"],
	                  COPPER_ORE_COUNT5_1_1["j"]),
	                  true, "Copper ore should be Prospectable")
					  
	-- Iron Ore and prof lvl are equals
	bagClass:setBagSlot(IRON_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(IRON_ORE_COUNT5_1_1["i"],
	                  IRON_ORE_COUNT5_1_1["j"]),
	                  true, "Iron Ore and prof lvl should be equals")
					  
	-- Iron ore and prof lvl are equals, stack small
	bagClass:setBagSlot(IRON_ORE_COUNT4_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(IRON_ORE_COUNT4_1_1["i"],
	                  IRON_ORE_COUNT4_1_1["j"]),
	                  false, "Iron ore and prof lvl are equals, stack 4 < 5!")
					  
	-- Fel Iron Ore
	bagClass:setBagSlot(FEL_IRON_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(FEL_IRON_ORE_COUNT5_1_1["i"],
	                  FEL_IRON_ORE_COUNT5_1_1["j"]),
	                 true, "Fel Iron Ore should not have been noticed")
					 
	-- Ghost Iron Ore
	bagClass:setBagSlot(GHOST_IRON_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(GHOST_IRON_ORE_COUNT5_1_1["i"],
	                  GHOST_IRON_ORE_COUNT5_1_1["j"]),
	                 true, "Ghost Iron Ore should not have been noticed")
					 
	-- Copper Bar
	bagClass:setBagSlot(COPPER_BAR_COUNT50_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(COPPER_BAR_COUNT50_1_1["i"],
	                  COPPER_BAR_COUNT50_1_1["j"]),
	                  false, "Copper ore is not Prospectingable")
					  
	-- Leystone Ore legion Ore
	bagClass:setBagSlot(LEYSTONE_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(LEYSTONE_ORE_COUNT5_1_1["i"],
	                  LEYSTONE_ORE_COUNT5_1_1["j"]),
	                  true, "Leystone Ore should be Prospectable")
					  
	-- Felslate Legion 
	bagClass:setBagSlot(FELSLATE_ORE_COUNT5_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(FELSLATE_ORE_COUNT5_1_1["i"],
	                  FELSLATE_ORE_COUNT5_1_1["j"]),
	                  true, "Felslate ore should be Prospectable")
					  
	-- Felslate Stack to small
	bagClass:setBagSlot(FELSLATE_ORE_COUNT4_1_1)
	self:assertEquals(DestroyusPro:isItemProspectingable(FELSLATE_ORE_COUNT4_1_1["i"],
	                  FELSLATE_ORE_COUNT4_1_1["j"]),
	                  false, "Stack size to low. ")
end