LegionTest = {}
LegionTest.__index = LegionTest

setmetatable(LegionTest, {
	__index = UnitTest, -- this is what makes the inheritance work
	__call = function (cls)
	  local self = setmetatable({}, cls)
	  UnitTest:_init(self)
	  return self
	end
  })

  function LegionTest.setUp(self)
	self.functionProfInfo = GetProfessionInfo
	self.functionGetProf = GetProfessions
	self.bagFunction =  GetContainerItemInfo
	self.GetContainerNumSlots = GetContainerNumSlots
	---
    GetContainerItemInfo = function(i, j) return bagClass:returnBagSlot(i, j) end
	GetContainerNumSlots = function(i) return bagClass:returnContainerNumSlot(i) end
	_profApi:setFirstProf(INSCRIPTION_LVL367_INDEX1)
	_profApi:setSecondProf(JEWELCRAFTING_LVL125_INDEX2)
	GetProfessions = function() return  _profApi:getProfessions() end
	GetProfessionInfo = function(index) return _profApi:getProfessionInfo(index) end
	

	DestroyusPro.ts.spellsMassMillLegion = {}
	DestroyusPro.ts.spellsMassProspectingLegion = {}
	DestroyusPro.ts.spellsMassMillAzeroth = {}
	DestroyusPro.ts.spellsMassProspectingAzeroth = {}
	DestroyusPro.ts.openTradeSkill = function() return  true end
	DestroyusPro.ts.closeTradeSkill = function() return  true end
	DestroyusPro.ts.craftRecipe = function() return true end
	DestroyusPro.ts.getRecipeInfo = function(self, spellID)
		result = {}
		result.learned = false
		if spellID == _DPSpellApi.spellMassMillDreamleaf or  spellID == _DPSpellApi.spellMassMillAethril or spellID == _DPSpellApi.spellMassProspectEmpyrium or
		  spellID == _DPSpellApi.spellMassProspecStormSilver or spellID == _DPSpellApi.spellMassMillSirensPollen or spellID == _DPSpellApi.spellMassMillWintersKiss then
		  result.learned = true
		  return result
		end
		return result
	end
end

function LegionTest.tearDown(self)
	GetProfessionInfo = self.functionProfInfo
	GetProfessions = self.functionGetProf
	GetContainerItemInfo = self.bagFunction
	GetContainerNumSlots = self.GetContainerNumSlots
	DestroyusPro.ts.spellsMassMillLegion = {}
	DestroyusPro.ts.spellsMassProspectingLegion = {}
	DestroyusPro.ts.spellsMassMillAzeroth = {}
	DestroyusPro.ts.spellsMassProspectingAzeroth = {}
end

function LegionTest.buildTestForCountItemToWorkMassProf(self, item, name)
	bagClass:setBagSlot(item)
	DestroyusPro:countItemToWork()
	self:assertEquals(DestroyusPro.countItem[item["itemId"]],
	item["count"], name .. " => Wrong counting number")
end

function LegionTest.clearTableCountItem(self)
	DestroyusPro:clearTableCountItem()
	for key in pairs(DestroyusPro.countItem) do
		self:assertEquals(DestroyusPro.countItem[key], 0,
						  string.format("%d have different value %d than 0",
						                key, DestroyusPro.countItem[key]))
	end
end

function LegionTest.buildTestForCountItemMultiple(self, first, second)
	bagClass:setBagSlot(first)
	DestroyusPro:countHerbAndOreMass(first["i"], first["j"])
	bagClass:setBagSlot(second)
	DestroyusPro:countHerbAndOreMass(second["i"], second["j"])
	bagClass:setBagSlot(first)
	DestroyusPro:countHerbAndOreMass(first["i"], first["j"])
	bagClass:setBagSlot(second)
	DestroyusPro:countHerbAndOreMass(second["i"], second["j"])
	self:assertEquals(DestroyusPro.countItem[first["itemId"]],
	first["count"] * 2, "Adding dont work")
	self:assertEquals(DestroyusPro.countItem[second["itemId"]],
	second["count"] * 2, "Adding dont work")
	self:clearTableCountItem()
end

function LegionTest.buildTestForSelectSpellToCast(self, item, spells, spellID, name)
	self:buildTestForCountItemToWorkMassProf(item, name)
	spell, amount = DestroyusPro:selectSpellToCast(spells)
	self:clearTableCountItem()
	self:assertEquals(spell, spellID, string.format("Wrong SpellID %s. Should be %d for %s", tostring(spell), spellID, name))
	if spellID ~= nil then
		self:assertEquals(amount, floor(item["count"] / DestroyusPro.minRequireAmountInStackForMasWork), string.format("Wrong amount of crafting stack %d for %s", amount, name))
	end
end

function LegionTest.test_countItemToWorkMilling(self)
	self:buildTestForCountItemToWorkMassProf(AETHRIL_COUNT20_3_12, "Aerhril")
	self:buildTestForCountItemToWorkMassProf(DREAMLEAF_COUNT19_1_12, "Dreamleaf")
	self:buildTestForCountItemToWorkMassProf(FELWORT_COUNT20_3_12, "Felwort")
	self:buildTestForCountItemToWorkMassProf(FAJARNSKAGGL_COUNT20_3_12, "Fjarnskaggl")
	self:buildTestForCountItemToWorkMassProf(FOXFLOWER_COUNT20_3_12, "Foxflower")
	self:buildTestForCountItemToWorkMassProf(STARLIGHT_ROSE_COUNT20_3_12, "Starlight Rose")
	self:buildTestForCountItemToWorkMassProf(YSERALLINE_SEED_COUNT20_3_12, "Yseralline Seed")
	self:buildTestForCountItemToWorkMassProf(ASTRAL_GLORY_COUNT20_3_10, "Astral Glory")
	self:clearTableCountItem()
end

function LegionTest.test_countItemToWorkProspecting(self)
	self:buildTestForCountItemToWorkMassProf(LEYSTONE_ORE_COUNT20_3_12, "Leystone Ore")
	self:buildTestForCountItemToWorkMassProf(FELSLATE_ORE_COUNT20_3_12, "Felstale Ore")
	self:buildTestForCountItemToWorkMassProf(EPYRIUM_ORE_COUNT20_3_11, "Epyrium Ore")
	self:clearTableCountItem()
end

function LegionTest.test_countHerbAndOreMassMultiple(self)
	self:buildTestForCountItemMultiple(STARLIGHT_ROSE_COUNT20_3_12,
	                                   EPYRIUM_ORE_COUNT20_3_11)
end

function LegionTest.test_selectSpellToCastMillingPositive(self)
	self:buildTestForSelectSpellToCast(AETHRIL_COUNT20_3_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillAethril, "Aerhril")
	self:buildTestForSelectSpellToCast(DREAMLEAF_COUNT20_1_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillDreamleaf, "Dreamleaf")
	self:buildTestForSelectSpellToCast(FELWORT_COUNT20_3_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillFelwort, "Felwort")
	self:buildTestForSelectSpellToCast(FAJARNSKAGGL_COUNT20_3_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillFjarnskaggl, "Fjarnskaggl")
	self:buildTestForSelectSpellToCast(FOXFLOWER_COUNT20_3_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillFoxflower, "Foxflower")
	self:buildTestForSelectSpellToCast(STARLIGHT_ROSE_COUNT20_3_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillStarlightRose, "Starlight Rose")
	self:buildTestForSelectSpellToCast(YSERALLINE_SEED_COUNT20_3_12, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillYserallineSeeds, "Yseralline Seed")
	self:buildTestForSelectSpellToCast(ASTRAL_GLORY_COUNT20_3_10, SPELLS_ALL_MILLING_LEGION, _DPSpellApi.spellMassMillAstralGlory, "Astral Glory")
end

function LegionTest.test_selectSpellToCastMillingNegative(self)
	self:buildTestForSelectSpellToCast(AETHRIL_COUNT19_3_12, SPELLS_ALL_MILLING_LEGION, nil, "Aerhril")
	self:buildTestForSelectSpellToCast(DREAMLEAF_COUNT19_1_12, SPELLS_ALL_MILLING_LEGION, nil, "Dreamleaf")
	self:buildTestForSelectSpellToCast(FELWORT_COUNT19_3_12, SPELLS_ALL_MILLING_LEGION, nil, "Felwort")
	self:buildTestForSelectSpellToCast(FAJARNSKAGGL_COUNT19_3_12, SPELLS_ALL_MILLING_LEGION, nil, "Fjarnskaggl")
	self:buildTestForSelectSpellToCast(FOXFLOWER_COUNT19_3_12, SPELLS_ALL_MILLING_LEGION, nil, "Foxflower")
	self:buildTestForSelectSpellToCast(STARLIGHT_ROSE_COUNT19_3_12, SPELLS_ALL_MILLING_LEGION, nil, "Starlight Rose")
	self:buildTestForSelectSpellToCast(YSERALLINE_SEED_COUNT19_3_12, SPELLS_ALL_MILLING_LEGION, nil, "Yseralline Seed")
	self:buildTestForSelectSpellToCast(ASTRAL_GLORY_COUNT19_3_10, SPELLS_ALL_MILLING_LEGION, nil, "Astral Glory")
end

function LegionTest.test_selectSpellToCastProspectingPositive(self)
	self:buildTestForSelectSpellToCast(LEYSTONE_ORE_COUNT20_3_12, SPELLS_ALL_PROSPECTING_LEGION, _DPSpellApi.spellMassProspecLeystone, "Leystone Ore")
	self:buildTestForSelectSpellToCast(FELSLATE_ORE_COUNT20_3_12, SPELLS_ALL_PROSPECTING_LEGION, _DPSpellApi.spellMassProspectFelslate, "Felstale Ore")
	self:buildTestForSelectSpellToCast(EPYRIUM_ORE_COUNT20_3_11, SPELLS_ALL_PROSPECTING_LEGION, _DPSpellApi.spellMassProspectEmpyrium, "Epyrium Ore")
end

function LegionTest.test_selectSpellToCastProspectingNegative(self)
	self:buildTestForSelectSpellToCast(LEYSTONE_ORE_COUNT19_3_12, SPELLS_ALL_PROSPECTING_LEGION, nil, "Leystone Ore")
	self:buildTestForSelectSpellToCast(FELSLATE_ORE_COUNT19_3_12, SPELLS_ALL_PROSPECTING_LEGION, nil, "Felstale Ore")
	self:buildTestForSelectSpellToCast(EPYRIUM_ORE_COUNT19_3_11, SPELLS_ALL_PROSPECTING_LEGION, nil, "Epyrium Ore")
end

function LegionTest.test_selectSpellToCastPartial(self)
	self:buildTestForSelectSpellToCast(AETHRIL_COUNT20_3_12, SPELLS_AETHRIL_YSERALL_FJARNSKAGGL_LEYSTONE_EMPYRIUM, _DPSpellApi.spellMassMillAethril, "Aerhril")
	self:buildTestForSelectSpellToCast(DREAMLEAF_COUNT20_1_12, SPELLS_AETHRIL_YSERALL_FJARNSKAGGL_LEYSTONE_EMPYRIUM, nil, "Dreamleaf")
	self:buildTestForSelectSpellToCast(EPYRIUM_ORE_COUNT20_3_11, SPELLS_AETHRIL_YSERALL_FJARNSKAGGL_LEYSTONE_EMPYRIUM, _DPSpellApi.spellMassProspectEmpyrium, "Epyrium Ore")
end

function BattleOfAzerothTest.buildIsSpellLearned(self, spellID, spells, learned)
	if learned then
		self:assertEquals(DestroyusPro.ts:isSpellLearned(spellID, spells), learned, string.format("Spell %s, Should be added to elements of table", _DPSpellApi(spellID):getSpellName()))
	else
		self:assertEquals(DestroyusPro.ts:isSpellLearned(spellID, spells), learned, string.format("Spell %s, Already exisit in the table with elements", _DPSpellApi(spellID):getSpellName()))
	end
end

function BattleOfAzerothTest.buildMassSpellLearned(self, spellsToLearn, spellsLearned, elements, extraSpellID)
	for key, spellID in ipairs(spellsToLearn) do
		self:buildIsSpellLearned(spellID, spellsLearned, false)
	end
	self:assertEquals(table.getn(spellsLearned), 0, "Table size should be 0")

	for key, spellID in ipairs(spellsToLearn) do
		DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_LEARNED", spellID)
		self:buildIsSpellLearned(spellID, spellsLearned, true)
	end

	DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_LEARNED", _DPSpellApi.unknowSpellId)
	DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_WRONG_EVENT", extraSpellID)
	DestroyusProMain.massSpellLearned(DestroyusProMain, "NEW_RECIPE_LEARNED", extraSpellID)
	self:buildIsSpellLearned(_DPSpellApi.unknowSpellId, spellsLearned, false)
	self:assertEquals(table.getn(spellsLearned), elements, "Table size should be 8")
end

function BattleOfAzerothTest.test_collectMassSpells(self)
	DestroyusPro.ts:collectAllMassSpells()
	self:buildIsSpellLearned(_DPSpellApi.spellMassProspectEmpyrium, DestroyusPro.ts.spellsMassProspectingLegion, true)
	self:buildIsSpellLearned(_DPSpellApi.spellMassProspectFelslate, DestroyusPro.ts.spellsMassProspectingLegion, false)
	self:buildIsSpellLearned(_DPSpellApi.spellMassMillDreamleaf, DestroyusPro.ts.spellsMassMillLegion, true)
	self:buildIsSpellLearned(_DPSpellApi.spellMassMillAethril, DestroyusPro.ts.spellsMassMillLegion, true)
	self:buildIsSpellLearned(_DPSpellApi.spellMassMillYserallineSeeds, DestroyusPro.ts.spellsMassMillLegion, false)
end

function BattleOfAzerothTest.test_massSpellLearned(self)
	self:buildMassSpellLearned(_DPSpellApi.spellsMassMillLegion, DestroyusPro.ts.spellsMassMillLegion, 8, _DPSpellApi.spellMassMillYserallineSeeds)
	self:buildMassSpellLearned(_DPSpellApi.spellsMassProspectingLegion, DestroyusPro.ts.spellsMassProspectingLegion, 3, _DPSpellApi.spellMassProspectFelslate)
end